.686p
.model	flat, stdcall
.nolist
include windows.inc
inv equ invoke
; some miscellaneous macros
soff Macro QuotedText:Vararg	; returns offset to a string
Local LocalText
.data
LocalText db QuotedText,0
.code
EXITM <offset LocalText>
Endm

uselib	MACRO	libname
	include		libname.inc
	includelib	libname.lib
ENDM

uselib user32
uselib kernel32
uselib comctl32
uselib shell32
.listall

DlgProc		PROTO :DWORD,:DWORD,:DWORD,:DWORD

.data?
hInst    dd ?
hWin     dd ?
hFnt	 dd ?

.code
Program:
	inv	GetModuleHandle, NULL
	mov hInst,eax
	inv	InitCommonControls
	inv	DialogBoxParam, hInst, 101, 0, ADDR DlgProc, 0
	inv	ExitProcess, eax

DlgProc	proc uses edi ebx hWnd:DWORD, uMsg:DWORD, wParam:DWORD, lParam:DWORD
    .if uMsg== WM_INITDIALOG
        mov eax,hWnd    ; save handle for everyone
        mov hWin,eax
		call GetAllHandles
	    call AdjustPosition
    .elseif uMsg == WM_SIZE
	    call AdjustPosition
	.elseif	uMsg == WM_CLOSE
		inv	EndDialog,hWin,0
	.endif

	xor	eax,eax
	ret
DlgProc	endp

;------------------------  control and window placement code -------------------------------------
.data
Tw	  dd 0    ;	Tw= width of dialog
OrigX dd 9    ;	OrigX = left of 1st control
OrigY dd 10   ; OrigY = top of 1st control
Rm    dd 0    ;	Rm= right margin =  Tw-OrigX
D1    dd 8	  ;	D1 = delta of leftmost control inside groupbox
Rm2   dd 0    ;	Rm2 = right margin within group = Rm-D1
Ht    dd 20   ;	Ht = Height of all controls
NFiles1 dd 0  ;	NFiles1 = number of files in wap
NFiles2 dd 0  ;	NFiles2 = number of other files
Bw1   dd 75   ;	Bw1 = width of "Set As Default" buttons
Bw2   dd 17   ;	Bw2 = width of "..." buttons
D2    dd 2    ;	D2  = delta between "set as" and "..." buttons
			  ;     =  also delta between folder name and "..." button
W2    dd 26   ;	W2  = width of "Type" and center edits of wap files
dwp	  dd 0    ; multi position window structure handle

blank   db ' ',0
edt		db 'EDIT',0,0
.data?
WinRect   RECT <?>  ; left,top,right,bottom of Dialog window
TmpId   dd ?
tbuf db 100 dup (?)
.code

Ids textequ <9001,1000,9002,2002,2001,1001,9003,2004,2003,1002,9004,1003,9033,9006,9007,9008,3001,3002,3003,9034,9012,4001,4002,4003,2005,2006>

ControlData Struc
   h dd ? ; handle
   L dd ? ; Left
   T dd ? ; Top
   W dd ? ; Width
   H dd ? ; Height
ControlData Ends

GetAllHandles Proc
; Get data space for handle, left, top, width, height for each control
.data?
	%For T1,<Ids>
		c&T1& ControlData <?>
	EndM
	ConRect RECT <?>
.code
	; get the handles
	%For T1,<Ids>
		inv GetDlgItem,hWin,T1
		mov c&T1&.h,eax
    EndM
	ret
GetAllHandles EndP

SetControlPos Proc loc:dword, L:dword, T:dword, W:dword, H:dword
	mov edx,loc
	.if edx!=0
		pdata equ [edx].ControlData  ; how to get to data using edx as base register
		mov eax,L
		mov pdata.L,eax
		mov eax,T	                    	
		mov pdata.T,eax
		mov eax,W
		mov pdata.W,eax
		mov eax,H
		mov pdata.H,eax
	
		mov eax,pdata.h
	.else
		inv GetDlgItem,hWin,TmpId
	.endif
	inv MoveWindow,eax,L,T,W,H,TRUE
	ret
SetControlPos EndP

AdjustPosition Proc
	push ebx
    inv GetWindowRect,hWin,ADDR WinRect ; get window position
    mov eax,WinRect.right
    sub eax,WinRect.left
    sub eax,6
	mov Tw,eax
	shr eax,1
	mov eax,Tw
	sub eax,OrigX
	mov Rm,eax
	sub eax,D1
	mov Rm2,eax
	mov NFiles1,7	; for test
	mov NFiles2,9

;		  Left             Top         Width       Height
;	9001  OrigX           OrigY          93         
	inv SetControlPos,addr c9001,OrigX,OrigY,93,Ht         
;	1000  OrigX+9001W+3   9001T-2    Rm-1000L
	mov eax,OrigX
	add eax,c9001.W
	add eax,3
	mov ebx,c9001.T
	sub ebx,2
	mov ecx,Rm
	sub ecx,eax
	inv SetControlPos,addr c1000,eax,ebx,ecx,Ht
;	9002  OrigX           OrigY+23  Rm-Bw1-Bw2-D2-D2-OrigX-5
	mov eax,OrigX
	mov ebx,OrigY
	add ebx,23
	mov ecx,Rm
	sub ecx,Bw1
	sub ecx,Bw2
	sub ecx,D2
	sub ecx,D2
	sub ecx,5
	sub ecx,OrigX
	inv SetControlPos,addr c9002,eax,ebx,ecx,Ht
	inv InvalidateRect,dword ptr c9002,0,FALSE
;	2002  Rm-Bw1-1        9002T+13     Bw1
	mov eax,Rm
	sub eax,Bw1
	sub eax,2
	mov ebx,c9002.T
	add ebx,13
	inv SetControlPos,addr c2002,eax,ebx,Bw1,Ht
;	2001  2002L-Bw2-2     2002T         Bw2
	mov eax,c2002.L
	sub eax,Bw2
	sub eax,2
	inv SetControlPos,addr c2001,eax,c2002.T,Bw2,Ht
;	1001  OrigX           2002T         9002W
	inv SetControlPos,addr c1001,OrigX,c2002.T,c9002.W,Ht
;	9003  OrigX           1001T+24      9002W
	mov ebx,c1001.T
	add ebx,24
	inv SetControlPos,addr c9003,OrigX,ebx,c9002.W,Ht
	inv InvalidateRect,dword ptr c9003,0,FALSE
;	2004  2002L           9003T+13      Bw1
	mov ebx,c9003.T
	add ebx,13
	inv SetControlPos,addr c2004,c2002.L,ebx,Bw1,Ht
;	2003  2001L           2004T         Bw2
	inv SetControlPos,addr c2003,c2001.L,c2004.T,Bw2,Ht
;	1002  OrigX           2004T        9002W
	inv SetControlPos,addr c1002,OrigX,ebx,c9002.W,Ht
	
;	9004  OrigX           1002T+32       125
	mov ebx,c1002.T
	add ebx,32
	inv SetControlPos,addr c9004,OrigX,ebx,125,Ht
;	1003  OrigX+9004W+3   9004T-1      Rm-9004W-13
	mov eax,OrigX
	add eax,c9004.W
	add eax,3
	mov ebx,c9004.T
	sub ebx,1
	mov ecx,Rm
	sub ecx,c9004.W
	sub ecx,13
	inv SetControlPos,addr c1003,eax,ebx,ecx,Ht
;	9033  OrigX           9004T+26     Rm-OrigX    35 + nfiles1*Ht
	mov eax,NFiles1
	mov ebx,Ht
	mul ebx
	mov edx,eax
	add edx,35
	mov ebx,c9004.T
	add ebx,26
	mov ecx,Rm
	sub ecx,OrigX
	inv SetControlPos,addr c9033,OrigX,ebx,ecx,edx
;	9006  OrigX+D1        9033T+13  (9033W-W2-2*14)/2
	mov eax,OrigX
	add eax,D1
	mov ebx,c9033.T
	add ebx,13
	mov ecx,c9033.W
	sub ecx,W2
	sub ecx,28
	shr ecx,1
	inv SetControlPos,addr c9006,eax,ebx,ecx,Ht
	inv InvalidateRect,dword ptr c9006,0,FALSE
;	9007  9006R+5           9006T          W2
	mov eax,c9006.L
	add eax,c9006.W
	add eax,5
	inv SetControlPos,addr c9007,eax,c9006.T,W2,Ht
;	9008  9007R+5           9006T        Rm-L-10
	mov eax,c9007.L
	add eax,c9007.W
	add eax,5
	mov ecx,Rm
	sub ecx,eax
	sub ecx,10
	inv SetControlPos,addr c9008,eax,c9006.T,ecx,Ht
	inv InvalidateRect,dword ptr c9008,0,FALSE
;	3001  OrigX+D1        9006T+13     9006W
	mov eax,OrigX
	add eax,D1
	mov ebx,c9006.T
	add ebx,13
	inv SetControlPos,addr c3001,eax,ebx,c9006.W,Ht	
;	3002  9007L           3001T          W2
	inv SetControlPos,addr c3002,c9007.L,c3001.T,W2,Ht	
;	3003  9008L           3001T        9006W
	inv SetControlPos,addr c3003,c9008.L,c3001.T,c9008.W,Ht

.data?
TmpFile dd ?
RowT    dd ?  ; top of current row
temp1   dd ?
.code
	mov TmpFile,2	; doing 2nd file
	mov TmpId,3004	; first id to do
	mov eax,c3001.T
	mov RowT,eax
@@:
	mov eax,TmpFile
	cmp eax,NFiles1
	jg	@f			; done
	mov eax,Ht
	add RowT,eax
;	3004+ 9006L           3001T+Ht*TmpFile   9006W
	inv GetDlgItem,hWin,TmpId
	.if eax==0
		inv CreateWindowEx,WS_EX_CLIENTEDGE,addr edt,addr blank,
				WS_VISIBLE or WS_CHILD or ES_NOHIDESEL or ES_MULTILINE or WS_CLIPSIBLINGS,
		        c9006.L,RowT,c9006.W,Ht,hWin,TmpId,temp1,NULL
		inv SendMessage,eax,WM_SETFONT,hFnt,TRUE
	.endif
	inv SetControlPos,0,c9006.L,RowT,c9006.W,Ht

;	3005+ 9007L           3004T          W2
	add TmpId,1
	inv GetDlgItem,hWin,TmpId
	.if eax==0
		inv CreateWindowEx,WS_EX_CLIENTEDGE,addr edt,addr blank,
				WS_VISIBLE or WS_CHILD or ES_NOHIDESEL or ES_MULTILINE or WS_CLIPSIBLINGS,
		        c9007.L,RowT,W2,Ht,hWin,TmpId,temp1,NULL
		inv SendMessage,eax,WM_SETFONT,hFnt,TRUE
	.endif
	inv SetControlPos,0,c9007.L,RowT,W2,Ht

;	3006+ 9008L           3004T        9006W
	add TmpId,1
	inv GetDlgItem,hWin,TmpId
	.if eax==0
		inv CreateWindowEx,WS_EX_CLIENTEDGE,addr edt,addr blank,
				WS_VISIBLE or WS_CHILD or ES_NOHIDESEL or ES_MULTILINE or WS_CLIPSIBLINGS,
		        c9008.L,RowT,c9008.W,Ht,hWin,TmpId,temp1,NULL
		inv SendMessage,eax,WM_SETFONT,hFnt,TRUE
	.endif
	inv SetControlPos,0,c9008.L,RowT,c9008.W,Ht

	add TmpId,1
	add TmpFile,1 
	jmp @b
@@:

;	9034  OrigX           9033T+9033H+4  9033W    35 + nfiles2*Ht
	mov eax,NFiles2
	mov ebx,Ht
	mul ebx
	mov edx,eax
	add edx,35

	mov ebx,c9033.T
	add ebx,c9033.H
	add ebx,2
	mov eax,Ht
	sub eax,1
	inv SetControlPos,addr c9034,OrigX,ebx,c9033.W,edx
;	9012  9007L           9034T+13       W2
	mov ebx,c9034.T
	add ebx,13
	inv SetControlPos,addr c9012,c9007.L,ebx,W2,Ht
;	4001  c9006L     9012T+13     9006W
	mov ebx,c9012.T
	add ebx,13
	inv SetControlPos,addr c4001,c9006.L,ebx,c9006.W,Ht	
;	4002  9012L+7         4001T          15
	mov eax,c9012.L
	add eax,7
	inv SetControlPos,addr c4002,eax,c4001.T,15,Ht
;	4003  9008L           4001T        9006W
	inv SetControlPos,addr c4003,c9008.L,c4001.T,c9008.W,Ht	

	mov TmpFile,2	; doing 2nd file
	mov TmpId,4004	; first id to do
	mov eax,c4001.T
	mov RowT,eax
@@:
	mov eax,TmpFile
	cmp eax,NFiles2
	jg	@f			; done
	mov eax,Ht
	add RowT,eax
;	4004+ 9006L     4001T+Ht   9006W
	inv GetDlgItem,hWin,TmpId
	.if eax==0
		inv CreateWindowEx,WS_EX_CLIENTEDGE,addr edt,addr blank,
				WS_VISIBLE or WS_CHILD or ES_NOHIDESEL or ES_MULTILINE or WS_CLIPSIBLINGS,
		        c9006.L,RowT,c9006.W,Ht,hWin,TmpId,temp1,NULL
		inv SendMessage,eax,WM_SETFONT,hFnt,TRUE
	.endif
	inv SetControlPos,0,c9006.L,RowT,c9006.W,Ht

;	4005+ 4002L           4004T        4002W
	add TmpId,1
	inv GetDlgItem,hWin,TmpId
	.if eax==0
		inv CreateWindowEx,0,soff("Button"),addr blank,
				WS_VISIBLE or WS_CHILD or BS_AUTOCHECKBOX or WS_TABSTOP or WS_CLIPSIBLINGS,
		        c4002.L,RowT,c4002.W,Ht,hWin,TmpId,temp1,NULL
		inv SendMessage,eax,WM_SETFONT,hFnt,TRUE
	.endif
	inv SetControlPos,0,c4002.L,RowT,c4002.W,Ht
;	4006+ 9008L           4004T        9006W
	add TmpId,1
	inv GetDlgItem,hWin,TmpId
	.if eax==0
		inv CreateWindowEx,WS_EX_CLIENTEDGE,addr edt,addr blank,
				WS_VISIBLE or WS_CHILD or ES_NOHIDESEL or ES_MULTILINE or WS_CLIPSIBLINGS,
		        c9008.L,RowT,c9008.W,Ht,hWin,TmpId,temp1,NULL
		inv SendMessage,eax,WM_SETFONT,hFnt,TRUE
	.endif
	inv SetControlPos,0,c9008.L,RowT,c9008.W,Ht

	add TmpId,1
	add TmpFile,1 
	jmp @b
@@:

;	2005    9007L-65     9034T+9034H+4  69
	mov eax,c9007.L
	sub eax,65
	mov ebx,c9034.T
	add ebx,c9034.H
	add ebx,4
	mov ecx,69
	inv SetControlPos,addr c2005,eax,ebx,ecx,Ht	
;	2006    2005L+87      2005T          69
	mov eax,c2005.L
	add eax,87
	inv SetControlPos,addr c2006,eax,c2005.T,c2005.W,Ht
	
	pop ebx
	ret
AdjustPosition EndP

end Program